import argparse
from time import sleep

from edps import __version__
from edps.client.EDPSClient import EDPSClient


def main():
    parser = argparse.ArgumentParser(description=f"EDPS client version {__version__}")
    parser.add_argument("-H", "--host", help='e.g. "localhost"', default="localhost", type=str)
    parser.add_argument("-P", "--port", help='e.g. "5000"', default=5000, type=int)
    parser.add_argument("-n", "--nowait", help="Return immediately, don't wait for EDPS to close", default=False, action='store_true')
    args = parser.parse_args()
    client = EDPSClient(args.host, args.port)
    client.shutdown_edps()
    if not args.nowait:
        return wait_until_cant_connect(client)


def wait_until_cant_connect(client):
    while True:
        try:
            client.get_edps_version()
            sleep(1)
        except Exception as e:
            return


if __name__ == '__main__':
    main()
